﻿using System;

namespace EnigmaLib
{
    interface IUiRotor
    {
        /// <summary>Get current position.</summary>
        int Position { get; }
        /// <summary>Get start position. To set start position, use
        /// SetStartPosition(), ManualAdvance(), ManualReverse()</summary>
        int StartPosition { get; }
        /// <summary>Set start position and reset position to it</summary>
        /// <param name="position"></param>
        void SetStartPosition(int position);
        /// <summary>Revert to start position</summary>
        void Reset();
        void Clear();
        char GetVisibleLetter();
        /// <summary>Advance this rotor only. Ignore notches. Set starting position</summary>
        void ManualAdvance();
        /// <summary>Reverse this rotor only. Ignore notches. Set starting position</summary>
        void ManualReverse();

        // StaticRotor wrappers
        string Name { get; set; }
        void SetRing(char ringSetting);

        event EventHandler PositionChanged;
        event EventHandler RingSettingsChanged;
        event EventHandler StartPositionChanged;
    }
}
