using System;

namespace EnigmaLib
{
    public static class StaticLib
    {
        /// <summary>Convert alphabetic char to ordinal 0-25</summary>
        /// <param name="c">Upper or lower case alphabetic char</param>
        /// <returns>0-based alphabetic ordinal: 0-25</returns>
        public static int CharToInt26(char c)
        {
            int i = (int)c;
            if (i > 64 && i < 91)
                return i - 65;
            if (i > 96 && i < 123)
                return i - 97;
            throw new Exception("Out of range");
        }
        /// <summary>Convert alphabetic ordinal 0-25 to its letter A-Z</summary>
        /// <param name="i">0-based alphabetic ordinal: 0-25</param>
        /// <returns>Upper case alphabetic char</returns>
        public static char Int26ToChar(int i)
        {
            if (i < 0 || i > 25)
                throw new Exception("Out of range");
            return (char)(i + 65);
        }

        public static int[] GetInt26Array()
        {
            // need an invalid default value to test against.
            // use -1 as invalid value since 0 is a valid value
            int[] iArr = new int[26];
            for (int i = 0; i < 26; i++)
                iArr[i] = -1;
            return iArr;
        }
    }
}
