using System;
using EnigmaLib;

namespace HistoricalEnigma
{
    public enum HistoricalRotors { I, II, III, IV, V, VI, VII, VIII, Beta, Gamma }
    public enum HistoricalReflectors { A, B, C, BThin, CThin }

    /// <summary>Get instances of historical pieces</summary>
    public static class HistoryFactory
    {
        #region rotors
        public static Rotor RotorI()
        {
            Rotor r = new Rotor("EKMFLGDQVZNTOWYHXUSPAIBRCJ", 'Q');
            r.Name = "I";
            return r;

            //StaticRotor rotor = new StaticRotor("EKMFLGDQVZNTOWYHXUSPAIBRCJ", 'Q');
            //rotor.Name = "I";
            //return new Rotor(rotor);

        }
        public static Rotor RotorII()
        {
            StaticRotor rotor = new StaticRotor("AJDKSIRUXBLHWTMCQGZNPYFVOE", 'E');
            rotor.Name = "II";
            return new Rotor(rotor);
        }
        public static Rotor RotorIII()
        {
            StaticRotor rotor = new StaticRotor("BDFHJLCPRTXVZNYEIWGAKMUSQO", 'V');
            rotor.Name = "III";
            return new Rotor(rotor);
        }
        public static Rotor RotorIV()
        {
            StaticRotor rotor = new StaticRotor("ESOVPZJAYQUIRHXLNFTGKDCMWB", 'J');
            rotor.Name = "IV";
            return new Rotor(rotor);
        }
        public static Rotor RotorV()
        {
            StaticRotor rotor = new StaticRotor("VZBRGITYUPSDNHLXAWMJQOFECK", 'Z');
            rotor.Name = "V";
            return new Rotor(rotor);
        }
        public static Rotor RotorVI()
        {
            StaticRotor rotor = new StaticRotor("JPGVOUMFYQBENHZRDKASXLICTW", 'Z', 'M');
            rotor.Name = "VI";
            return new Rotor(rotor);
        }
        public static Rotor RotorVII()
        {
            StaticRotor rotor = new StaticRotor("NZJHGRCXMYSWBOUFAIVLPEKQDT", 'Z', 'M');
            rotor.Name = "VII";
            return new Rotor(rotor);
        }
        public static Rotor RotorVIII()
        {
            StaticRotor rotor = new StaticRotor("FKQHTLXOCBJSPDZRAMEWNIUYGV", 'Z', 'M');
            rotor.Name = "VIII";
            return new Rotor(rotor);
        }
        public static Rotor RotorBeta()
        {
            StaticRotor rotor = new StaticRotor("LEYJVCNIXWPBQMDRTAKZGFUHOS");
            rotor.Name = "Beta";
            return new Rotor(rotor);
        }
        public static Rotor RotorGamma()
        {
            StaticRotor rotor = new StaticRotor("FSOKANUERHMBTIYCWLQPZXVGJD");
            rotor.Name = "Gamma";
            return new Rotor(rotor);
        }
        #endregion
        #region reflectors
        public static Reflector ReflectorA()
        {
            Reflector reflector = new Reflector("EJMZALYXVBWFCRQUONTSPIKHGD");
            reflector.Name = "A";
            return reflector;
        }
        public static Reflector ReflectorB()
        {
            Reflector reflector = new Reflector("YRUHQSLDPXNGOKMIEBFZCWVJAT");
            reflector.Name = "B";
            return reflector;
        }
        public static Reflector ReflectorC()
        {
            Reflector reflector = new Reflector("FVPJIAOYEDRZXWGCTKUQSBNMHL");
            reflector.Name = "C";
            return reflector;
        }
        public static Reflector ReflectorBThin()
        {
            Reflector reflector = new Reflector("ENKQAUYWJICOPBLMDXZVFTHRGS");
            reflector.Name = "B (Thin)";
            return reflector;
        }
        public static Reflector ReflectorCThin()
        {
            Reflector reflector = new Reflector("RDOBJNTKVEHMLFCWZAXGYIPSUQ");
            reflector.Name = "C (Thin)";
            return reflector;
        }
        #endregion
    }
}
